#!/bin/bash

##(1)

gnuplot <<EOF
set terminal postscript eps enhanced color
set output "problem3_3_2_1.eps"
set size 0.7 , 0.5
set xlabel "Time[tick]"
set ylabel "Price"
set format x "%1.1f {/Symbol \264} 10^6"
set xtics rotate by -75
plot "data.dat" u (\$0/1000000):1 noti w l
EOF

##(2)

awk '
{
	if(NR >= 2 && $1 != before ){
		print($1-before);
	}
	before = $1;
}
' data.dat > problem3_3_2_2.dat


gnuplot <<EOF
set terminal postscript eps enhanced color
set output "problem3_3_2_2.eps"
set size 0.7 , 0.5
set xlabel "Time[tick]"
set ylabel "Diff"
set format x "%1.1f {/Symbol \264} 10^6"
set xtics rotate by -75
plot "problem3_3_2_2.dat" u (\$0/1000000):1 noti w l 
EOF


##(3)

gcc -o problem3_3_2_3.exe problem3_3_2_3.c

#the number of data
line=$(cat problem3_3_2_2.dat | wc -l )

./problem3_3_2_3.exe	${line}


gnuplot <<EOF
set terminal postscript eps enhanced color
set output "problem3_3_2_3.eps"
set size 0.6 , 0.6
set xlabel "Absolute value of Diff Price"
set ylabel "PDF"
set format x "10^{%L}"
set format y "10^{%L}"
set log xy
plot	"problem3_3_2_3.dat" noti w p pt 7  ,\
		10**-1*x**-3 title "x^{-3}"  w l lw 3
EOF



##(4)
##note : awk -v -> use the shellscript-variable in awk

sort -nr problem3_3_2_2.dat |\
awk -v line="${line}" '
{
	print $1,NR/line
}
' > problem3_3_2_4.dat



gnuplot <<EOF
set terminal postscript eps enhanced color
set output "problem3_3_2_4.eps"
set size 0.6 , 0.6
set xlabel "Absolute value of Diff Price"
set ylabel "CDF"
set xrange [10**-3:1]
set yrange [ :1]
set format x "10^{%L}"
set format y "10^{%L}"
set log xy
plot	"problem3_3_2_4.dat" noti w l,\
		10**-5*x**-2 title "x^{-2}"  w l lw 3
EOF
